#ifndef _MELEE_H
#include "melee.h"
#endif

#ifndef _AI_H
#define _AI_H

class AI_Player;
class AI_Player_Earthling;
class AI_Player_Yehat;
class AI_Player_Pkunk;
class AI_Player_Utwig;
class AI_Player_Arilou;
class AI_Player_Slylandro;
class AI_Player_Chmmr;
//class AI_Player_Ilwrath;
//class AI_Player_Supox;

//////////////////////////////
class KeyState {
  public:
  bool thrust;
  bool turn_left;
  bool turn_right;
  bool fire_weapon;
  bool fire_special;
  int convert();
};
class AI_Player {
  public:
   double debug_double;
   double debug_double1;

   KeyState k;

   int  state;        // Current state of AI
   bool select_state; // Change or not current state of AI
   Ship *ai_ship;     // AI ship

   double trajectory_angle(double x1, double y1, double x2, double y2);

   void act (int a);
   void notact (int a);

   virtual void Stop();
   virtual void Chase(SpaceLocation *enemy);
   virtual void Runaway(SpaceLocation *enemy, double range);
   virtual void Turnface(SpaceLocation *enemy, double angle);
   virtual void Attack(SpaceLocation *enemy);
   virtual void Evade(SpaceLocation *enemy);
   bool isTarget(SpaceLocation *enemy);     // Shot will hit us?
   bool nearPlanet();                       // Planet near the us?

   virtual void CheckShots(); // check all enemy shots
   virtual void ProcessShot(SpaceLocation *shot, double range); // subfunction of CheckShots()

   virtual void calculate();
   virtual void change_state();

   AI_Player(Ship *ai);
};

//////////////////////////////
AI_Player *init_ai(Ship *ai, char *ID);

/////////////////////// IMPLEMENTED AI CLASSES ////////////////////
class AI_Player_Earthling : public AI_Player {
  protected:
   int close_table[20];

  public:
  AI_Player_Earthling(Ship *ai);

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};

///////////////////////
class AI_Player_Yehat : public AI_Player {
  public:
  AI_Player_Yehat(Ship *ai);

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};
///////////////////////
class AI_Player_Utwig : public AI_Player {
  public:
  AI_Player_Utwig(Ship *ai);

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};
///////////////////////
class AI_Player_Pkunk : public AI_Player {
  protected:
   int evade_table[20];

  public:
  AI_Player_Pkunk(Ship *ai);

  virtual void Attack(SpaceLocation *enemy);
  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};
///////////////////////
class AI_Player_Arilou : public AI_Player {
  public:
  AI_Player_Arilou(Ship *ai);

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};
///////////////////////
class AI_Player_Slylandro : public AI_Player {
  public:
  AI_Player_Slylandro(Ship *ai);

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};

///////////////////////
class AI_Player_Chmmr : public AI_Player {
  public:
  AI_Player_Chmmr(Ship *ai);
  bool TractorBeam;
//  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};

///////////////////////
/*class AI_Player_Ilwrath : public AI_Player {
  public:
  AI_Player_Ilwrath(Ship *ai);

  bool cloaked;

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
};

class AI_Player_Supox : public AI_Player {
  public:
  AI_Player_Supox(Ship *ai);

  virtual void ProcessShot(SpaceLocation *shot, double range); 
  virtual void calculate();
  virtual void change_state();
}; */

#endif
