/*
If you don't want to require JGMOD, then uncomment the NO_JGMOD #define.
Ditto AASTR.
Like, duh.

SLOW_CHARACTER disables the optimized version of animate_character, 
which may have issues.

NO_ALLEGRO_4 is for use with Allegro 3.12 and earlier... which isn't
portable, and doesn't work with versions of JGMOD... only for use as a last
resort.
*/

//#define   NO_JGMOD
//#define   NO_AASTR
//#define   SLOW_CHARACTER
//#define   NO_ALLEGRO_4

#ifdef NO_ALLEGRO_4
  #define acquire_screen()
  #define release_screen()
  #define set_keyboard_rate(a,b)
  #define END_OF_MAIN()
  #define poll_keyboard()
  #define KEY_MAX 128
#endif

#ifdef NO_AASTR
  #define aa_stretch_sprite stretch_sprite
#else
  #include <aastr.h>
#endif

#ifdef NO_JGMOD
  #define set_mod_volume(a)
  #define play_mod(a,b)
  #define stop_mod()
  #define is_mod_playing() 0
  #define remove_mod()
  #define install_mod(a)
  #define pause_mod()
  #define resume_mod()
#else
  #include <jgmod.h>
#endif
