#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <allegro.h>
#include <string.h>

#include "melee.h"
#include "libs.h"



#define SCPGUI_MUSIC   0
#define SCPGUI_TITLE   1

#define MAIN_DIALOG_MELEE    0
#define MAIN_DIALOG_KEYSONE  1
#define MAIN_DIALOG_KEYSTWO  2
#define MAIN_DIALOG_FLEETONE 3
#define MAIN_DIALOG_FLEETTWO 4
#define MAIN_DIALOG_OPTIONS  5
#define MAIN_DIALOG_EXIT     6

#define KEY_DIALOG_MODIFY 0
#define KEY_DIALOG_OK     1
#define KEY_DIALOG_CANCEL 2

#define FLEET_DIALOG_FLEETTITLE    0
#define FLEET_DIALOG_FLEETLIST     1
#define FLEET_DIALOG_SHIPLIST      2
#define FLEET_DIALOG_SELECT        3
#define FLEET_DIALOG_CLEAR         4
#define FLEET_DIALOG_PLAYERBOX     5
#define FLEET_DIALOG_PLAYERTEXT    6
#define FLEET_DIALOG_SAVE          7
#define FLEET_DIALOG_LOAD          8
#define FLEET_DIALOG_TITLE         9
#define FLEET_DIALOG_MAIN          10

//#define OPTIONS_DIALOG_BOX        0
//#define OPTIONS_DIALOG_GAMMATEXT  1
//#define OPTIONS_DIALOG_GAMMANUM   2
#define OPTIONS_DIALOG_GAMMA      3
//#define OPTIONS_DIALOG_COLORTEXT  4
#define OPTIONS_DIALOG_8bit       5
#define OPTIONS_DIALOG_15bit      6
#define OPTIONS_DIALOG_16bit      7
#define OPTIONS_DIALOG_MUSIC      8
#define OPTIONS_DIALOG_SOUND      9
#define OPTIONS_DIALOG_ZOOM       10
#define OPTIONS_DIALOG_PLAYER1    11
#define OPTIONS_DIALOG_PLAYER1_H  12 //
#define OPTIONS_DIALOG_PLAYER1_D  13 // radio
#define OPTIONS_DIALOG_PLAYER1_S  14 //
#define OPTIONS_DIALOG_PLAYER2    15
#define OPTIONS_DIALOG_PLAYER2_H  16 //
#define OPTIONS_DIALOG_PLAYER2_D  17 // radio
#define OPTIONS_DIALOG_PLAYER2_S  18 //
#define OPTIONS_DIALOG_OK         19
#define OPTIONS_DIALOG_CANCEL     20
#define OPTIONS_DIALOG_AA		  21

#define TITLE_DIALOG_BOX    0
#define TITLE_DIALOG_EDIT   1
#define TITLE_DIALOG_OK     2
#define TITLE_DIALOG_CANCEL 3

int compatible_soundcard = FALSE;  // is compatible sound card?
int  gamma_correction     = 0;      // gamma factor
int play_music           = FALSE;  // play music?
int play_sound           = FALSE;  // play sound FX?
char gamma_number[3];               // for options dialog only

DATAFILE *scp;

FILE *debug_file;

void showTitle();
void setKeys(Control &player);
void change_options();
void init_video();
void init_sound();
void init_modem();
void init_gamma();
void (*tw_draw_rle_sprite)(BITMAP *bmp, RLE_SPRITE *sprite, int x, int y);

int update_gamma(void *dp3, int val);
int  getKey();

DIALOG mainDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_button_proc,     470,  10,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Melee" ,
  NULL, NULL },
  { d_button_proc,     470,  70,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Player One Keys" ,
  NULL, NULL },
  { d_button_proc,     470,  130,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Player Two Keys" ,
  NULL, NULL },
  { d_button_proc,     470,  190,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Player One Fleet" ,
  NULL, NULL },
  { d_button_proc,     470,  250,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Player Two Fleet" ,
  NULL, NULL },
  { d_button_proc,     470,  310,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Options" ,
  NULL, NULL },
  { d_button_proc,     470,  370,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Exit",
  NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char fleetPlayer[18];
char fleetTitleString[100];

DIALOG fleetDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   5,    160,  48,   255,  0,    0,    0,       0,    0,    fleetTitleString ,
  NULL, NULL },
  { d_list_proc,       10,   60,   160,  415,  255,  0,    0,    D_EXIT,  0,    0,    fleetListboxGetter ,
  NULL, NULL },
  { d_list_proc,       470,  5,    160,  350,  255,  0,    0,    D_EXIT,  0,    0,    shipListboxGetter ,
  NULL, NULL },
  { d_button_proc,     470,  365,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Ship" ,
  NULL, NULL },
  { d_button_proc,     470,  425,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Clear Slot" ,
  NULL, NULL },
  { d_box_proc,        240,  5,    160,  20,   255,  0,    0,    0,       0,    0,    NULL ,
  NULL, NULL },
  { d_ctext_proc,      320,  10,   160,  10,   255,  0,    0,    0,       0,    0,    fleetPlayer ,
  NULL, NULL },
  { d_button_proc,     240,  35,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Save Fleet" ,
  NULL, NULL },
  { d_button_proc,     240,  95,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Load Fleet" ,
  NULL, NULL },
  { d_button_proc,     240,  155,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Fleet Title" ,
  NULL, NULL },
  { d_button_proc,     240,  215,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main" ,
  NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char title_str[80];

DIALOG titleDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        180,  210,  280,  60,   255,  0,    0,    0,       0,    0,    NULL ,
  NULL, NULL },
  { d_edit_proc,       190,  220,  260,  10,   255,  0,    0,    0,       80,   0,    title_str ,
  NULL, NULL },
  { d_button_proc,     255,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK" ,
  NULL, NULL },
  { d_button_proc,     325,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel" ,
  NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char dialog_strings[16][80];

DIALOG keyDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    40,   20,   120,  32,   255,  0,    0,    0,       0,    0,    dialog_strings[0],
  NULL, NULL },
  { d_button_proc,     40,   200,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_strings[1],
  NULL, NULL },
  { d_button_proc,     440,  200,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_strings[2],
  NULL, NULL },
  { d_button_proc,     240,  130,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_strings[3],
  NULL, NULL },
  { d_button_proc,     240,  200,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_strings[4],
  NULL, NULL },
  { d_button_proc,     240,  270,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_strings[5],
  NULL, NULL },
  { d_button_proc,     140,  350,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Accept Changes",
  NULL, NULL },
  { d_button_proc,     340,  350,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Cancel",
  NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

DIALOG optionsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg) (bg) (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        50,   50,  320, 240,   255,  0,    0,    0,       0,    0,    NULL,
  NULL, NULL },
  { d_text_proc,       70,   85,  250,  10,   255,  0,    0,    0,       0,    0,    (void *)"Gamma Correction =",
  NULL, NULL },
  { d_text_proc,      180,   85,  050,  10,   255,  0,    0,    0,       0,    0,    gamma_number,
  NULL, NULL },
  { d_slider_proc,     70,  100,  200,  10,   255,  0,    0,    0,       100,  0,    NULL, update_gamma, NULL },
  { d_text_proc,       70,  125,  325,  10,   255,  0,    0,    0,       0,    0,    (void *)"Color Depth",
  NULL, NULL },
  { d_radio_proc,      70,  140,   55,  10,   255,  0,    0,    0,       1,    0,    (void *)"8 bit" ,
  NULL, NULL },
  { d_radio_proc,      70,  150,   55,  10,   255,  0,    0,    0,       1,    0,    (void *)"15 bit" ,
  NULL, NULL },
  { d_radio_proc,      70,  160,   55,  10,   255,  0,    0,    0,       1,    0,    (void *)"16 bit" ,
  NULL, NULL },
  { d_check_proc,      70,  180,   70,  15,   255,  0,    0,    0,       0,    0,    (void *)"Music ON" ,
  NULL, NULL },
  { d_check_proc,      69,  200,   70,  15,   255,  0,    0,    0,       0,    0,    (void *)"Sound ON" ,
  NULL, NULL },
  { d_check_proc,      69,  220,  100,  15,   255,  0,    0,    0,       0,    0,    (void *)"Zoom Discrete" ,
  NULL, NULL },
  
  { d_text_proc,      170,  125,  325,  10,   255,  0,    0,    0,       0,    0,    (void *)"Player1",
  NULL, NULL },
  { d_radio_proc,     170,  140,   55,  10,   255,  0,    0,    0,       2,    0,    (void *)"Human" ,
  NULL, NULL },
  { d_radio_proc,     170,  150,   55,  10,   255,  0,    0,    0,       2,    0,    (void *)"AI Dumb" ,
  NULL, NULL },
  { d_radio_proc,     170,  160,   55,  10,   255,  0,    0,    0,       2,    0,    (void *)"AI Smart" ,
  NULL, NULL },

  { d_text_proc,      270,  125,  325,  10,   255,  0,    0,    0,       0,    0,    (void *)"Player2",
  NULL, NULL },
  { d_radio_proc,     270,  140,   55,  10,   255,  0,    0,    0,       3,    0,    (void *)"Human" ,
  NULL, NULL },
  { d_radio_proc,     270,  150,   55,  10,   255,  0,    0,    0,       3,    0,    (void *)"AI Dumb" ,
  NULL, NULL },
  { d_radio_proc,     270,  160,   55,  10,   255,  0,    0,    0,       3,    0,    (void *)"AI Smart" ,
  NULL, NULL },

  { d_button_proc,     470, 100,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK" ,
  NULL, NULL },
  { d_button_proc,     470, 160,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel" ,
  NULL, NULL },
  { d_check_proc,      69,  240,  100,  15,   255,  0,    0,    0,       0,    0,    (void *)"Antialiasing" ,
  NULL, NULL },
  { NULL,              0,   0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};


char remark[80];

FONT *desktop_font;

////////////////// draw sprite without 'Gamma factor' ////////////////
void tw_draw_rle_sprite_nogamma (BITMAP *bmp, RLE_SPRITE *sprite, int x, int y)
{
 draw_rle_sprite(bmp, sprite,x, y);
}

///////////////// draw sprite with 'Gamma factor' ///////////////////
void tw_draw_rle_sprite_gamma(BITMAP *bmp, RLE_SPRITE *sprite, int x, int y)
{
 draw_lit_rle_sprite(bmp, sprite,x, y, gamma_correction);
}

void tw_draw_sprite(BITMAP *bmp, BITMAP *sprite, int x, int y)
{
 draw_lit_sprite (bmp, sprite, x, y, gamma_correction);
}

int update_gamma(void *dp3, int val)
{
 sprintf(gamma_number, "%d", val);
 return D_REDRAW;
}

void set_radio_color(int val)
{
 optionsDialog[OPTIONS_DIALOG_8bit].flags=0;
 optionsDialog[OPTIONS_DIALOG_15bit].flags=0;
 optionsDialog[OPTIONS_DIALOG_16bit].flags=0;

 switch (val){
  case 8: optionsDialog[OPTIONS_DIALOG_8bit].flags=D_SELECTED;break;
  case 15: optionsDialog[OPTIONS_DIALOG_15bit].flags=D_SELECTED;break;
  case 16: optionsDialog[OPTIONS_DIALOG_16bit].flags=D_SELECTED;break;
 }
}

int get_radio_id(int first)
{
 int i=0;
 while (optionsDialog[first+i].flags!=D_SELECTED) i++;
 return i;
}

////  variables
  int    mainRet = 0, shipRet = 0, keyRet = 0, fleetRet = 0, optionsRet= 0;
  int    color_depth = 16;

void break_all()
{
 tw_error("break");
 allegro_exit();
 exit(1);
}


int main() {
  char   path[80];
  int    mainLoop;
  int    player  = 0;
  ControlKB player1, player2;

  srandom(time(NULL));

  allegro_init();
  install_timer();
  install_keyboard();
  install_mouse();

  set_keyboard_rate(0,0);

  #ifdef SCP_DEBUG
  debug_file = fopen("SCP.LOG", "w");
  #endif

  set_config_file("scp.ini");

  play_music       = get_config_int("SCP", "PlayMusic", TRUE);
  play_sound       = get_config_int("SCP", "PlaySound", TRUE);
  color_depth      = get_config_int("SCP", "BitsPerPixel", 16);
  gamma_correction = get_config_int("SCP", "Gamma", 0);

  init_sound();
  init_video();
  init_ships();
  init_fleet();

  player1.load("scp.ini", "Player1");
  player2.load("scp.ini", "Player2");

  desktop_font = font;
  do {
    mainLoop = TRUE;

    install_keyboard();
    install_mouse();

    set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat));
    gui_fg_color = pallete_color[0];
    gui_bg_color = pallete_color[15];
    set_dialog_color(mainDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(keyDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(fleetDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(optionsDialog, pallete_color[0], pallete_color[15]);

    font = (FONT *)(scppal[SCPPAL_FONT].dat);
    if (play_music) play_mod((JGMOD *)(scp[SCPGUI_MUSIC].dat), TRUE);

    remark[0] = '\0';

    do {
      showTitle();
      mainRet = do_dialog(mainDialog, MAIN_DIALOG_MELEE);

      if(mainRet == MAIN_DIALOG_MELEE) {
        mainLoop = FALSE;
      } else
      if((mainRet == MAIN_DIALOG_KEYSONE) || (mainRet == MAIN_DIALOG_KEYSTWO))
      {
        player = mainRet - MAIN_DIALOG_KEYSONE;
        if (player == 0) setKeys(player1); else setKeys(player2);
      } else
      if((mainRet == MAIN_DIALOG_FLEETONE) || (mainRet == MAIN_DIALOG_FLEETTWO))
      {
        if(mainRet == MAIN_DIALOG_FLEETONE) {
          load_fleet("scp.ini", "Fleet1");
          sprintf(fleetPlayer, "Player One Fleet");
        } else {
          load_fleet("scp.ini", "Fleet2");
          sprintf(fleetPlayer, "Player Two Fleet");
        }

        do {
          sprintf(title_str, fleet_title);
          sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);

          showTitle();
          fleetRet = do_dialog(fleetDialog, FLEET_DIALOG_SHIPLIST);

          if((fleetRet == FLEET_DIALOG_SELECT) ||
            (fleetRet == FLEET_DIALOG_SHIPLIST)) {
            select_fleet_slot(
              fleetDialog[FLEET_DIALOG_FLEETLIST].d1,
              fleetDialog[FLEET_DIALOG_SHIPLIST].d1);
            fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
          }

          if((fleetRet == FLEET_DIALOG_CLEAR) ||
            (fleetRet == FLEET_DIALOG_FLEETLIST)) {
            clear_fleet_slot(fleetDialog[FLEET_DIALOG_FLEETLIST].d1);
            fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
          }

          if(fleetRet == FLEET_DIALOG_SAVE) {
            font = desktop_font;
            sprintf(path, "fleets/");
            if(file_select("Save Fleet", path, "scf"))
              save_fleet(path, "Fleet");
            font = (FONT *)(scppal[SCPPAL_FONT].dat);
          }

          if(fleetRet == FLEET_DIALOG_LOAD) {
            font = desktop_font;
            sprintf(path, "fleets/");
            if(file_select("Load Fleet", path, "scf"))
              load_fleet(path, "Fleet");
            sprintf(title_str, fleet_title);
            sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);
            font = (FONT *)(scppal[SCPPAL_FONT].dat);
          }

          if(fleetRet == FLEET_DIALOG_TITLE) {
            font = desktop_font;
            if(do_dialog(titleDialog, TITLE_DIALOG_BOX) == TITLE_DIALOG_OK)
              sprintf(fleet_title, title_str);
            font = (FONT *)(scppal[SCPPAL_FONT].dat);
          }
        } while((fleetRet != FLEET_DIALOG_MAIN) && (fleetRet != -1));
        if(mainRet == MAIN_DIALOG_FLEETONE)
          save_fleet("scp.ini", "Fleet1");
        else
          save_fleet("scp.ini", "Fleet2");
      } else
      if(mainRet == MAIN_DIALOG_OPTIONS) change_options();
    } while((mainLoop) && (mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));

    if (play_music) stop_mod();

    unload_datafile(scp);


    if(mainRet == MAIN_DIALOG_MELEE) {
      font = desktop_font;
      acquire_screen();
      clear(screen);
      release_screen();
      play_melee(&player1, &player2);
      font = (FONT *)(scppal[SCPPAL_FONT].dat);
    }

   scp = load_datafile("scpgui.dat"); //loading all data again

  } while((mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));

  remove_mod();
  remove_sound();
  remove_keyboard();
  remove_mouse();
  remove_timer();

  unload_datafile(scppal);

  allegro_exit();

  return 0;
}
END_OF_MAIN();

void showTitle() {
  acquire_screen();
  blit((BITMAP *)(scp[SCPGUI_TITLE].dat), screen, 0, 0, 0, 0, 640, 480);
  release_screen();
  if(remark[0] != '\0') {
    acquire_screen();
    textout_centre(screen, font, remark, 230, 230, pallete_color[15]);
    release_screen();
    remark[0] = '\0';
  }
}

void setKeys (Control &p) {
  int i, t = 0;
  while (true) {
    showTitle();
    strncpy ( dialog_strings[0], p.name,   15);
    strncat ( dialog_strings[0], ":\nSet Your Keys",   30);
    strncpy ( dialog_strings[1], "Left:       ", 15);
    strncpy ( dialog_strings[2], "Right: ", 15);
    strncpy ( dialog_strings[3], "Thrust: ", 15);
    strncpy ( dialog_strings[4], "Fire: ", 15);
    strncpy ( dialog_strings[5], "Special: ",15);
    strncpy ( dialog_strings[1]+6, key_strings[p.left], 15);
    strncpy ( dialog_strings[2]+7, key_strings[p.right], 15);
    strncpy ( dialog_strings[3]+8, key_strings[p.thrust], 15);
    strncpy ( dialog_strings[4]+6, key_strings[p.fire], 15);
    strncpy ( dialog_strings[5]+9, key_strings[p.special], 15);
    i = do_dialog(keyDialog, 1);
    if (i <= 5) {
      t = readkey() >> 8;
    }
    if (t == KEY_ESC) i = 7;
    switch (i) {
      case 1:
        p.left = t;
        break;
      case 2:
        p.right = t;
        break;
      case 3:
        p.thrust = t;
        break;
      case 4:
        p.fire = t;
        break;
      case 5:
        p.special = t;
        break;
      case 6:
        p.save("scp.ini", p.name);
        return;
      case 7:
        p.load("scp.ini", p.name);
        return;
      }
    }
  }

void tw_error(char* message) {
#ifdef _WIN32
  MessageBox(win_get_window(), message, "Star CoNETrol", MB_ICONSTOP);
#else
  printf("Error: %s", message);
#endif
}

int getKey() {
//  #ifdef _WIN32
//    while(1)
//      for(int i = 0; i < KEY_MAX; i++)
//        if(key[i] != 0) {
//		  return i;
//		}
//  #else
    unsigned i;
    

    while(!keypressed()) poll_keyboard();

    i = 0;
    while((!key[i]) && (i < KEY_MAX)) i++;

    while(keypressed()) poll_keyboard();
  

    return(i);
//  #endif
}



//////////// Initializing gamma /////////////
void init_gamma()
{
//  tw_draw_rle_sprite = &tw_draw_rle_sprite_nogamma;
  tw_draw_rle_sprite=&tw_draw_rle_sprite_gamma;
  set_trans_blender(255, 255, 255, 0);
/*  RGB *pal = (RGB*)scppal[SCPPAL_PALLETE].dat;
  int scale = 100 + gamma_correction;
  for (int i = 0; i < 256; i += 1) {
    int tmp;
    tmp = int((pal[i].r+1) * scale / 101);
    if (tmp > 63) tmp = 63;
    pal[i].r = tmp;
    tmp = int((pal[i].g+1) * scale / 101);
    if (tmp > 63) tmp = 63;
    pal[i].g = tmp;
    tmp = int((pal[i].b+1) * scale / 101);
    if (tmp > 63) tmp = 63;
    pal[i].b = tmp;
  }
  set_pallete(pal);*/
}

//////////// Initializing video /////////////
void init_video()
{
  if((color_depth != 8) && (color_depth != 15)) color_depth = 16;

  set_color_depth(color_depth);
  set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);

  scppal = load_datafile("scppal.dat");
  if(!scppal) {
    tw_error("Error loading SCP pallete data\n");
    allegro_exit();
    exit(1);
  }

  init_gamma();
  acquire_screen();
  clear(screen);
  release_screen();

//  set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat));
  set_dialog_color(mainDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(keyDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(fleetDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(optionsDialog, pallete_color[0], pallete_color[15]);

  scp = load_datafile("scpgui.dat");
  if(!scp) {
    tw_error("Error loading SCP GUI data\n");
	allegro_exit();
    exit(1);
   }

}

//////////// Initializing sound /////////////
void init_sound()
{
  compatible_soundcard=FALSE;
  if (detect_digi_driver(DIGI_AUTODETECT)>=32){
    compatible_soundcard=true;
    reserve_voices(32, -1);
    if (install_sound(DIGI_AUTODETECT, MIDI_NONE, "")<0) compatible_soundcard=FALSE;
    install_mod(8);
   }

   if (!compatible_soundcard)
   {
    play_music=FALSE;
    play_sound=FALSE;

    // protection from WINDOWS hangups when play music in other apps
    // (there's problem of _detection_ routine in Allegro :(((((
    tw_error("Initializing soundcard.....FAILURE\n");
    #ifndef _WIN32
	getc(stdin);
    #endif
   }
}


//////////// "Options Dialog" /////////////
void change_options()
{
  int new_bpp; 
  int change_sound = true;
  int ai1, ai2;

  set_config_file("scp.ini");
  color_depth = get_config_int("SCP", "BitsPerPixel", 16);
  gamma_correction=get_config_int("SCP", "Gamma", 0);
  play_music = get_config_int("SCP", "PlayMusic", TRUE);
  play_sound = get_config_int("SCP", "PlaySound", TRUE);
  zoom_discrete = get_config_int("SCP", "Zoom", TRUE);
  zoom_antia = get_config_int("SCP", "Anti-Aliasing", TRUE);
  ai1 = get_config_int("Player1", "AI", 0);
  ai2 = get_config_int("Player2", "AI", 0);

  ///////// setup "options dialog" settings
   if (!compatible_soundcard) {
      play_music = FALSE;
      play_sound = FALSE;
    change_sound = FALSE; // don't write sound settings to ini file

    optionsDialog[OPTIONS_DIALOG_MUSIC].flags = 0 | D_DISABLED;
    optionsDialog[OPTIONS_DIALOG_SOUND].flags = 0 | D_DISABLED;
   }

   if (play_music) optionsDialog[OPTIONS_DIALOG_MUSIC].flags = D_SELECTED;
   if (play_sound) optionsDialog[OPTIONS_DIALOG_SOUND].flags = D_SELECTED;
   if (zoom_discrete) optionsDialog[OPTIONS_DIALOG_ZOOM].flags = D_SELECTED;
   if (zoom_antia) optionsDialog[OPTIONS_DIALOG_AA].flags = D_SELECTED;

   if (color_depth>8)optionsDialog[OPTIONS_DIALOG_GAMMA].flags=0;
    else optionsDialog[OPTIONS_DIALOG_GAMMA].flags=D_DISABLED;

  optionsDialog[OPTIONS_DIALOG_GAMMA].d2=gamma_correction;
  sprintf(gamma_number, "%d", gamma_correction);
  set_radio_color(color_depth);

  
  optionsDialog[OPTIONS_DIALOG_PLAYER1_H].flags=0;
  optionsDialog[OPTIONS_DIALOG_PLAYER1_D].flags=0;
  optionsDialog[OPTIONS_DIALOG_PLAYER1_S].flags=0;
  optionsDialog[OPTIONS_DIALOG_PLAYER2_H].flags=0;
  optionsDialog[OPTIONS_DIALOG_PLAYER2_D].flags=0;
  optionsDialog[OPTIONS_DIALOG_PLAYER2_S].flags=0;

  optionsDialog[OPTIONS_DIALOG_PLAYER1_H+ai1].flags=D_SELECTED;
  optionsDialog[OPTIONS_DIALOG_PLAYER2_H+ai2].flags=D_SELECTED;

  //////////
  showTitle();
  optionsRet = do_dialog(optionsDialog, OPTIONS_DIALOG_OK);

  ///////// setup sound 
   if (compatible_soundcard){
    if (optionsDialog[OPTIONS_DIALOG_MUSIC].flags==D_SELECTED) {
      play_music=true;
      if (is_mod_playing()==FALSE) play_mod((JGMOD *)(scp[SCPGUI_MUSIC].dat), TRUE);
    } else {
       play_music=FALSE;
       stop_mod();
      }
    if (optionsDialog[OPTIONS_DIALOG_SOUND].flags==D_SELECTED) play_sound=true;
     else play_sound=FALSE;
   }

  if (optionsDialog[OPTIONS_DIALOG_ZOOM].flags==D_SELECTED) zoom_discrete=true;
   else zoom_discrete=FALSE;

  if (optionsDialog[OPTIONS_DIALOG_AA].flags==D_SELECTED) zoom_antia=TRUE;
   else zoom_antia=FALSE;

  if (optionsRet == OPTIONS_DIALOG_OK){
   gamma_correction=optionsDialog[OPTIONS_DIALOG_GAMMA].d2;

  ///////// setup Color Depth

   new_bpp=get_radio_id(OPTIONS_DIALOG_8bit);
   switch(new_bpp){
    case 0: new_bpp = 8; 
            break;
    case 1: new_bpp = 15; 
            break;
    case 2: new_bpp = 16; 
            break;
   default: new_bpp = 16;
   }
   
   if (color_depth!=new_bpp) {
     color_depth=new_bpp;
     if (is_mod_playing()!=FALSE) {
      pause_mod();
      init_video();
      resume_mod();
      } else init_video();
    }
 
   init_gamma();

  ///////// save new settings
    ai1=get_radio_id(OPTIONS_DIALOG_PLAYER1_H);
    ai2=get_radio_id(OPTIONS_DIALOG_PLAYER2_H);

    set_config_int("Player1", "AI", ai1);
    set_config_int("Player2", "AI", ai2);

    set_config_file("scp.ini");
    set_config_int("SCP", "BitsPerPixel", color_depth);
    set_config_int("SCP", "Gamma", gamma_correction);
    set_config_int("SCP", "Zoom", zoom_discrete);
	set_config_int("SCP", "Anti-Aliasing", zoom_antia);
    if (change_sound){
     set_config_int("SCP", "PlayMusic", play_music);
     set_config_int("SCP", "PlaySound", play_sound);
    }
  }
}