
#include "../melee.h"

class SpathiEluder : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  double       specialRange;
  double       specialVelocity;
  int          specialDamage;
  int          specialArmour;
  double       specialTurnRate;

  public:
  SpathiEluder(double ox, double oy, double shipAngle,
    int shipCollideFlag, int shipRadarColor, ShipData *shipData);

  virtual int activate_weapon();
  virtual int activate_special();
};

SpathiEluder::SpathiEluder(double ox, double oy, double shipAngle,
  int shipCollideFlag, int shipRadarColor, ShipData *shipData) :
  Ship(ox, oy, shipAngle, shipCollideFlag, shipRadarColor, shipData)
{

  weaponRange    = get_config_float("Weapon", "Range", 0) * RANGE_RATIO;
  weaponVelocity = get_config_float("Weapon", "Velocity", 0) / VELOCITY_RATIO;
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);

  specialRange    = get_config_float("Special", "Range", 0) * RANGE_RATIO;
  specialVelocity = get_config_float("Special", "Velocity", 0) / VELOCITY_RATIO;
  specialDamage   = get_config_int("Special", "Damage", 0);
  specialArmour   = get_config_int("Special", "Armour", 0);
  specialTurnRate = get_config_float("Special", "TurnRate", 0);
}

int SpathiEluder::activate_weapon()
{
  spaceFrame->addSpaceObject(LAYER_SHOTS, new Missile(0.0, -(height() / 2.0),
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, this, data->spriteWeapon));
  return(TRUE);
}

int SpathiEluder::activate_special()
{
  spaceFrame->addSpaceObject(LAYER_SHOTS, new HomingMissile(
    0.0, height() / 2.0, angle + 180.0, specialVelocity, specialDamage,
    specialRange, specialArmour, specialTurnRate, this, data->spriteSpecial));
  return(TRUE);
}

Ship *getSpathiEluder(double sX, double sY, double sAngle,
  int sCollideFlag, int sRadarColor, ShipData *sData)
{
  return(new SpathiEluder(sX, sY, sAngle, sCollideFlag, sRadarColor, sData));
}

SHIP_REGISTER_INFO SpathiEluderInfo =
{
  "spael",
  "Spathi Eluder",
  getSpathiEluder
};
